
#ifndef _CM_LIB_CTRL_
#define	_CM_LIB_CTRL_


#include <pspkernel.h>
#include <pspsdk.h>
#include <pspctrl.h>
#include <pspctrl_kernel.h>
#include <stdbool.h>
#include <stdio.h>
#include <string.h>


#define LIB_CTRL_ALL (PSP_CTRL_SELECT | PSP_CTRL_START | PSP_CTRL_UP | PSP_CTRL_RIGHT | \
PSP_CTRL_DOWN | PSP_CTRL_LEFT | PSP_CTRL_LTRIGGER | PSP_CTRL_RTRIGGER | PSP_CTRL_TRIANGLE | \
PSP_CTRL_CIRCLE | PSP_CTRL_CROSS | PSP_CTRL_SQUARE | PSP_CTRL_NOTE | PSP_CTRL_HOME | \
PSP_CTRL_SCREEN | PSP_CTRL_VOLUP | PSP_CTRL_VOLDOWN )

/**
 * [U[[hŎg{^ׂ̓͂Ėɂ
 * ̃vOC̊֐gĂꍇA
 * łIɂĂvOC{^͖̓͂܂B
 * 
 * @param status - ꂼ̃vOCł̃I/Itۑ|C^B
 * 		libctrlMaskAllButtonOnlibctrlMaskAllButtonOffȊOł̒lύXƂȂ܂B
 *
 * @return 0 , < 0 siɃIɂȂĂj
 */
int libctrlMaskAllButtonOn(bool *status);

/**
 * [U[[hŎg{^ׂ̓͂ėLɂ
 * ̃vOC̊֐gĂꍇA
 * ׂẴvOCItɂĂȂƃ{^̓͂LɂȂ܂B
 * 
 * @param status - ꂼ̃vOCł̃I/Itۑ|C^B
 * 		libctrlMaskAllButtonOnlibctrlMaskAllButtonOffȊOł̒lύXƂȂ܂B
 *
 * @return 0 , < 0 siɃItɂȂĂj
 */
int libctrlMaskAllButtonOff(bool *status);

/**
 * {^ׂ̓͂ėLǂׂ
 *
 * @return true L, false 
 */
bool libctrlMaskAllButtonStatus();

/**
 * {^̗̓͂L/ăZbg
 * ̃vOC̊֐gĂꍇA
 * łIɂĂvOC{^͖̓͂A
 * ׂẴvOCItɂȂĂ{^̓͂͗LɂȂ܂B
 *
 * @return true L, false 
 */
bool libctrlMaskAllButtonAgain();

/**
 * w肵{^̓͂𖳌ɂĩvOCƋ\܂j
 * nƂ́u+vu|vłȂŉB
 * 
 * @param PspCtrlButtons - ɂ{^
 *
 * @return 0
 */
int libctrlMaskButtonOn(int PspCtrlButtons);

/**
 * w肵{^̓͂LɂĩvOCƋ\܂j
 * nƂ́u+vu|vłȂŉB
 * 
 * @param PspCtrlButtons - Lɂ{^
 *
 * @return 0
 */
int libctrlMaskButtonOff(int PspCtrlButtons);

/**
 * w肵{^̗L/𒲂ׂ܂
 * ɕnƂǂȂ邩͕s
 * 
 * @param PspCtrlButtons - ׂ{^
 *
 * @return true L, false 
 */
bool libctrlMaskButtonStatus(int PspCtrlButtons);

/**
 * w肵{^Ă邩ǂ𒲂ׂ܂
 * ɕnƂ́u+vu|vłȂŉB
 * 
 * @param buttons - ׂ{^
 * @param count - ̕b
 *
 * @return 1 w莞Ԃ܂ŉ , 0 w莞ԂɂȂOɗ
 *
 */
int libctrlCountButtons(u32 buttons, int count);

/**
 * w肵{^܂ő҂
 * ɕnƂ́u+vu|vłȂŉB
 * 
 * @param buttons - {^
 *
 * @return 0
 *
 */
int libctrlWaitButtonUp(u32 buttons);

/**
 * w肵{^܂ő҂
 * ɕnƂ́u+vu|vłȂŉB
 * 
 * @param buttons - {^
 *
 * @return 0
 *
 */
int libctrlWaitButtonDown(u32 buttons);


#endif
